
<template>
  <q-page class="flex">
    <div class="doc-container minheight-rows with-bg">
      <div class="row title-row items-center margin-bottom-20">
        <i class="fas fa-list-ul"></i>
        <div class="page-title">{{ $t('Catalog') }}</div>
      </div>
      <div class="row justify-start margin-bottom-20">
        <div class="col-6">
          <q-search v-model="searchedApp"
                    :float-label="$t('application.search')"
          ></q-search>
        </div>
      </div>

      <div class="row sm-gutter">
        <q-card inline
                class="application"
                v-for="(item, index) in filteredItems"
                :key="index"
                style="margin-bottom: 15px"
        >
          <q-card-media class="vanilla">
            <img src="../../assets/application.png">
          </q-card-media>
          <q-item>
            <q-item-main>
              <q-item-tile label>{{ item.name }}</q-item-tile>
            </q-item-main>
            <q-item-side :avatar="item.picture"
                         class="avatar"/>
          </q-item>
          <q-card-main>
            <span>{{ item.description }}</span>
          </q-card-main>
          <q-card-separator />
          <q-card-actions class="justify-end">
            <div class="col-6" >
              <q-btn outline rounded
                     class="action-btn full-width"
                     @click="startDownload(item)"
                     v-if="applicationCanBeDownloaded(item)"
              >{{ $t('state.download') }}</q-btn>
              <q-btn flat rounded disabled
                     class="action-btn full-width readonly"
                     v-else
              > {{appStateLabel(item)}}</q-btn>
            </div>
          </q-card-actions>
        </q-card>
      </div>

      <!--<div class="row">-->
        <!--<div class="col-12 app-list">-->
          <!--<div v-for="app in applications" :key="app.name" class="col-1">-->
            <!--<ApplicationCard :application="app" @click="appClicked(app.bundle)"/>-->
          <!--</div>-->
        <!--</div>-->
      <!--</div>-->
    </div>
  </q-page>
</template>

<script>
import {
  mapActions,
  mapState
} from 'vuex'
import ApplicationCard from '../../components/application_card'

export default {
  name: 'Applications',
  data: () => ({
    searchedApp: ''
  }),
  methods: {
    ...mapActions('applications', [
      'listApps',
      'downloadApp'
    ]),
    startDownload: function (app) {
      this.downloadApp(app.bundle)
    },
    appClicked: function (bundle) {
      console.log(bundle)
      this.$router.push('/applications/' + bundle)
    },
    refreshStateTimeout: function () {
      this.listApps()
    },
    enableCheckTimeout: function () {
      this.timeoutInterval = setInterval(() => {
        this.refreshStateTimeout()
      }, 5000)
    },
    appStateLabel: function (app) {
      if (app.currentState === app.targetState && app.currentState === 'installed') {
        return this.$t('state.installed')
      } else if (app.currentState === app.targetState && app.currentState === 'downloaded') {
        return this.$t('state.downloaded')
      } else if (app.targetState === 'downloaded' && app.currentState === 'installed') {
        return this.$t('state.stopping')
      } else if (app.targetState === 'uninstalled' && app.currentState === 'downloaded') {
        return this.$t('state.removing')
      } else if (app.targetState === 'installed') {
        return this.$t('state.installing')
      } else if (app.targetState === 'downloaded') {
        return this.$t('state.downloading')
      } else {
        return this.$t('state.download')
      }
    },
    applicationCanBeDownloaded: function (app) {
      return (app.currentState === null || app.currentState === 'uninstalled') &&
        (app.targetState === null || app.targetState === 'uninstalled')
    }
  },
  computed: {
    filteredItems: function () {
      if (!this.searchedApp) {
        return this.applications
      }
      return this.applications.filter(app => app.name.toLowerCase().includes(this.searchedApp.toLowerCase()))
    },
    ...mapState('applications', { applications: (state) => state.applications })
  },
  mounted: function () {
    this.refreshStateTimeout()
    this.enableCheckTimeout()
  },
  destroyed: function () {
    clearInterval(this.timeoutInterval)
  },
  components: {
    'ApplicationCard': ApplicationCard
  }

}
</script>
